<html>
<head>
<title>OgreMovableObject.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMovableObject.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMovableObject_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __MovableObject_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __MovableObject_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// Precompiler options</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderQueue_8h.html">OgreRenderQueue.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreAxisAlignedBox_8h.html">OgreAxisAlignedBox.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreSphere_8h.html">OgreSphere.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreShadowCaster_8h.html">OgreShadowCaster.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreFactoryObj_8h.html">OgreFactoryObj.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreAnimable_8h.html">OgreAnimable.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="OgreAny_8h.html">OgreAny.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="OgreUserObjectBindings_8h.html">OgreUserObjectBindings.h</a>&quot;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">namespace </span>Ogre {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045     <span class="comment">// Forward declaration</span>
<a name="l00046"></a>00046     <span class="keyword">class </span>MovableObjectFactory;
<a name="l00047"></a>00047 
<a name="l00059"></a><a class="code" href="classOgre_1_1MovableObject.html">00059</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ShadowCaster.html" title="This class defines the interface that must be implemented by shadow casters.">ShadowCaster</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AnimableObject.html" title="Defines an interface to classes which have one or more AnimableValue instances to expose...">AnimableObject</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">MovableAlloc</a>
<a name="l00060"></a>00060     {
<a name="l00061"></a>00061     <span class="keyword">public</span>:
<a name="l00064"></a><a class="code" href="classOgre_1_1MovableObject_1_1Listener.html">00064</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1MovableObject_1_1Listener.html" title="Listener which gets called back on MovableObject events.">Listener</a>
<a name="l00065"></a>00065         {
<a name="l00066"></a>00066         <span class="keyword">public</span>:
<a name="l00067"></a><a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#a358139c1e09d4c36c050861bd4f5b37e">00067</a>             <a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#a358139c1e09d4c36c050861bd4f5b37e">Listener</a>(<span class="keywordtype">void</span>) {}
<a name="l00068"></a><a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#a7731592ff0013b724f0be7a319a73fa8">00068</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#a7731592ff0013b724f0be7a319a73fa8">~Listener</a>() {}
<a name="l00070"></a><a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#a0cc50a90dbeb3d1049e923ee5866a636">00070</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#a0cc50a90dbeb3d1049e923ee5866a636" title="MovableObject is being destroyed.">objectDestroyed</a>(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>*) {}
<a name="l00072"></a><a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#a67127c7e6254c75a3e3f064e614a8152">00072</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#a67127c7e6254c75a3e3f064e614a8152" title="MovableObject has been attached to a node.">objectAttached</a>(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>*) {}
<a name="l00074"></a><a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#aa2a6f73325a1609a522a9d6dce5168cf">00074</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#aa2a6f73325a1609a522a9d6dce5168cf" title="MovableObject has been detached from a node.">objectDetached</a>(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>*) {}
<a name="l00076"></a><a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#a7383d0ff8a3e3777378e1a9f9661146f">00076</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#a7383d0ff8a3e3777378e1a9f9661146f" title="MovableObject has been moved.">objectMoved</a>(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>*) {}
<a name="l00081"></a><a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#a3935f0e525d63b03923aa67b137c0695">00081</a>             <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#a3935f0e525d63b03923aa67b137c0695" title="Called when the movable object of the camera to be used for rendering.">objectRendering</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>*, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>*) { <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00104"></a><a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#ad53d3feb40d1d1fb81db1cb620df6d8e">00104</a>             <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>* <a class="code" href="classOgre_1_1MovableObject_1_1Listener.html#ad53d3feb40d1d1fb81db1cb620df6d8e" title="Called when the movable object needs to query a light list.">objectQueryLights</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>*) { <span class="keywordflow">return</span> 0; }
<a name="l00105"></a>00105         };
<a name="l00106"></a>00106 
<a name="l00107"></a>00107     <span class="keyword">protected</span>:
<a name="l00109"></a><a class="code" href="classOgre_1_1MovableObject.html#a41954f454246b2935cdc90ab2f36dab8">00109</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1MovableObject.html#a41954f454246b2935cdc90ab2f36dab8" title="Name of this object.">mName</a>;
<a name="l00111"></a><a class="code" href="classOgre_1_1MovableObject.html#a884d3c2c8c8d8305f59eb171a7f56e56">00111</a>         <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject, and can be registered with Root in order to allow all clients to produce new instances of this object, integrated with the standard Ogre processing.">MovableObjectFactory</a>* <a class="code" href="classOgre_1_1MovableObject.html#a884d3c2c8c8d8305f59eb171a7f56e56" title="Creator of this object (if created by a factory)">mCreator</a>;
<a name="l00113"></a><a class="code" href="classOgre_1_1MovableObject.html#a5c05f316d061761a08fc036daedd0649">00113</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* <a class="code" href="classOgre_1_1MovableObject.html#a5c05f316d061761a08fc036daedd0649" title="SceneManager holding this object (if applicable)">mManager</a>;
<a name="l00115"></a><a class="code" href="classOgre_1_1MovableObject.html#a961db9b5f439708e0f24cb8dbeb9c728">00115</a>         <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* <a class="code" href="classOgre_1_1MovableObject.html#a961db9b5f439708e0f24cb8dbeb9c728" title="node to which this object is attached">mParentNode</a>;
<a name="l00116"></a><a class="code" href="classOgre_1_1MovableObject.html#a9f9b9e6981ef7ebbd6b9d82e93a2b299">00116</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject.html#a9f9b9e6981ef7ebbd6b9d82e93a2b299">mParentIsTagPoint</a>;
<a name="l00118"></a><a class="code" href="classOgre_1_1MovableObject.html#a8e7fa9ec69253b42ff4e7605b54e1a00">00118</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject.html#a8e7fa9ec69253b42ff4e7605b54e1a00" title="Is this object visible?">mVisible</a>;
<a name="l00120"></a><a class="code" href="classOgre_1_1MovableObject.html#ac439108451539e95ac9829ab6520306c">00120</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject.html#ac439108451539e95ac9829ab6520306c" title="Is debug display enabled?">mDebugDisplay</a>;
<a name="l00122"></a><a class="code" href="classOgre_1_1MovableObject.html#a0df899bfb650d8d51be51fa5f83743f4">00122</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1MovableObject.html#a0df899bfb650d8d51be51fa5f83743f4" title="Upper distance to still render.">mUpperDistance</a>;
<a name="l00123"></a><a class="code" href="classOgre_1_1MovableObject.html#a2635aafd01416e5a3346a647c2dfff52">00123</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1MovableObject.html#a2635aafd01416e5a3346a647c2dfff52">mSquaredUpperDistance</a>;
<a name="l00124"></a>00124         <span class="comment">// Minimum pixel size to still render</span>
<a name="l00125"></a><a class="code" href="classOgre_1_1MovableObject.html#a56e7d5ccac2877061b0919648f7f0b34">00125</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1MovableObject.html#a56e7d5ccac2877061b0919648f7f0b34">mMinPixelSize</a>;
<a name="l00127"></a><a class="code" href="classOgre_1_1MovableObject.html#a1f6c5390b42b10e00d3b21b8911aa3f4">00127</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject.html#a1f6c5390b42b10e00d3b21b8911aa3f4" title="Hidden because of distance?">mBeyondFarDistance</a>;    
<a name="l00129"></a><a class="code" href="classOgre_1_1MovableObject.html#af00b75d92e7d62f5ff9bd4847d1786e8">00129</a>         <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a> <a class="code" href="classOgre_1_1MovableObject.html#af00b75d92e7d62f5ff9bd4847d1786e8" title="User objects binding.">mUserObjectBindings</a>;
<a name="l00131"></a><a class="code" href="classOgre_1_1MovableObject.html#aa63b5c1cf9746a4caeb2a47a6bc1d2d6">00131</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1MovableObject.html#aa63b5c1cf9746a4caeb2a47a6bc1d2d6" title="The render queue to use when rendering this object.">mRenderQueueID</a>;
<a name="l00133"></a><a class="code" href="classOgre_1_1MovableObject.html#a2051828f33ea6c921e2979c8f00daa3f">00133</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject.html#a2051828f33ea6c921e2979c8f00daa3f" title="Flags whether the RenderQueue&#39;s default should be used.">mRenderQueueIDSet</a>;
<a name="l00135"></a><a class="code" href="classOgre_1_1MovableObject.html#aa34e0feb87409120726a489f52b39c58">00135</a>         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="classOgre_1_1MovableObject.html#aa34e0feb87409120726a489f52b39c58" title="The render queue group to use when rendering this object.">mRenderQueuePriority</a>;
<a name="l00137"></a><a class="code" href="classOgre_1_1MovableObject.html#ac9ee5f673870a76b23eb5291b3fa3f28">00137</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject.html#ac9ee5f673870a76b23eb5291b3fa3f28" title="Flags whether the RenderQueue&#39;s default should be used.">mRenderQueuePrioritySet</a>;
<a name="l00139"></a><a class="code" href="classOgre_1_1MovableObject.html#adf36b5bfcc9bce768bc5f8a9ed6b1464">00139</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1MovableObject.html#adf36b5bfcc9bce768bc5f8a9ed6b1464" title="Flags determining whether this object is included / excluded from scene queries.">mQueryFlags</a>;
<a name="l00141"></a><a class="code" href="classOgre_1_1MovableObject.html#a6db376fe4c048714224392901c98c3a5">00141</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1MovableObject.html#a6db376fe4c048714224392901c98c3a5" title="Flags determining whether this object is visible (compared to SceneManager mask)">mVisibilityFlags</a>;
<a name="l00143"></a><a class="code" href="classOgre_1_1MovableObject.html#a665c171729e2f37b66f73d0e6722ac2c">00143</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1MovableObject.html#a665c171729e2f37b66f73d0e6722ac2c" title="Cached world AABB of this object.">mWorldAABB</a>;
<a name="l00144"></a>00144         <span class="comment">// Cached world bounding sphere</span>
<a name="l00145"></a><a class="code" href="classOgre_1_1MovableObject.html#a271b08ae4cc604657c17125f76ec62e0">00145</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a> <a class="code" href="classOgre_1_1MovableObject.html#a271b08ae4cc604657c17125f76ec62e0">mWorldBoundingSphere</a>;
<a name="l00147"></a><a class="code" href="classOgre_1_1MovableObject.html#a00a9705c083b9fef8bbe762a5b1711a8">00147</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1MovableObject.html#a00a9705c083b9fef8bbe762a5b1711a8" title="World space AABB of this object&#39;s dark cap.">mWorldDarkCapBounds</a>;
<a name="l00149"></a><a class="code" href="classOgre_1_1MovableObject.html#ad21e8a5a6f0eeeefa3ec698781eaa3fa">00149</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject.html#ad21e8a5a6f0eeeefa3ec698781eaa3fa" title="Does this object cast shadows?">mCastShadows</a>;
<a name="l00150"></a>00150 
<a name="l00152"></a><a class="code" href="classOgre_1_1MovableObject.html#ad1291c87111d8944b2c49904a4d6280b">00152</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject.html#ad1291c87111d8944b2c49904a4d6280b" title="Does rendering this object disabled by listener?">mRenderingDisabled</a>;
<a name="l00154"></a><a class="code" href="classOgre_1_1MovableObject.html#a07fdbfc4ae0adb48f7619c0a44bd3890">00154</a>         <a class="code" href="classOgre_1_1MovableObject_1_1Listener.html" title="Listener which gets called back on MovableObject events.">Listener</a>* <a class="code" href="classOgre_1_1MovableObject.html#a07fdbfc4ae0adb48f7619c0a44bd3890" title="MovableObject listener - only one allowed (no list) for size &amp; performance reasons. */.">mListener</a>;
<a name="l00155"></a>00155 
<a name="l00157"></a><a class="code" href="classOgre_1_1MovableObject.html#a2626ce2a2f1c78027634cc92dfd2b211">00157</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a> <a class="code" href="classOgre_1_1MovableObject.html#a2626ce2a2f1c78027634cc92dfd2b211" title="List of lights for this object.">mLightList</a>;
<a name="l00159"></a><a class="code" href="classOgre_1_1MovableObject.html#af083212ba58f26eb7c747a0da749cc08">00159</a>         <span class="keyword">mutable</span> <a class="code" href="namespaceOgre.html#a4304981347643708ee9a7ba8884e5758">ulong</a> <a class="code" href="classOgre_1_1MovableObject.html#af083212ba58f26eb7c747a0da749cc08" title="The last frame that this light list was updated in.">mLightListUpdated</a>;
<a name="l00160"></a>00160 
<a name="l00162"></a><a class="code" href="classOgre_1_1MovableObject.html#a3db70b0c8b2e53a3c71671217e5a516c">00162</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1MovableObject.html#a3db70b0c8b2e53a3c71671217e5a516c" title="the light mask defined for this movable. This will be taken into consideration when deciding which li...">mLightMask</a>;
<a name="l00163"></a>00163 
<a name="l00164"></a>00164         <span class="comment">// Static members</span>
<a name="l00166"></a><a class="code" href="classOgre_1_1MovableObject.html#adeb3bbe50c1b6e92061461b363fc391e">00166</a> <span class="comment"></span>        <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1MovableObject.html#adeb3bbe50c1b6e92061461b363fc391e" title="Default query flags.">msDefaultQueryFlags</a>;
<a name="l00168"></a><a class="code" href="classOgre_1_1MovableObject.html#a24f37de53688fc5432d50c7ced03bd63">00168</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1MovableObject.html#a24f37de53688fc5432d50c7ced03bd63" title="Default visibility flags.">msDefaultVisibilityFlags</a>;
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172     <span class="keyword">public</span>:
<a name="l00174"></a>00174         <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>();
<a name="l00175"></a>00175 
<a name="l00177"></a>00177         <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00180"></a>00180         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>();
<a name="l00181"></a>00181 
<a name="l00183"></a><a class="code" href="classOgre_1_1MovableObject.html#a06f161ae0451be7eaa67e77c296d5631">00183</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#a06f161ae0451be7eaa67e77c296d5631" title="Notify the object of it&#39;s creator (internal use only)">_notifyCreator</a>(<a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject, and can be registered with Root in order to allow all clients to produce new instances of this object, integrated with the standard Ogre processing.">MovableObjectFactory</a>* fact) { mCreator = fact; }
<a name="l00185"></a><a class="code" href="classOgre_1_1MovableObject.html#abc4d3c30d2b50267a348f8d5aee3c5e4">00185</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject, and can be registered with Root in order to allow all clients to produce new instances of this object, integrated with the standard Ogre processing.">MovableObjectFactory</a>*  <a class="code" href="classOgre_1_1MovableObject.html#abc4d3c30d2b50267a348f8d5aee3c5e4" title="Get the creator of this object, if any (internal use only)">_getCreator</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCreator; }
<a name="l00187"></a><a class="code" href="classOgre_1_1MovableObject.html#af730ac3ee4a51ee69f4221298f933e8a">00187</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#af730ac3ee4a51ee69f4221298f933e8a" title="Notify the object of it&#39;s manager (internal use only)">_notifyManager</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* man) { mManager = man; }
<a name="l00189"></a><a class="code" href="classOgre_1_1MovableObject.html#a0c95a392476c6b54be1648a77f2a56c0">00189</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* <a class="code" href="classOgre_1_1MovableObject.html#a0c95a392476c6b54be1648a77f2a56c0" title="Get the manager of this object, if any (internal use only)">_getManager</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mManager; }
<a name="l00190"></a>00190 
<a name="l00192"></a><a class="code" href="classOgre_1_1MovableObject.html#a2c681d880b842c1b6d2c2b30b72b6660">00192</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1MovableObject.html#a2c681d880b842c1b6d2c2b30b72b6660" title="Returns the name of this object.">getName</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00193"></a>00193 
<a name="l00195"></a>00195         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00196"></a>00196 
<a name="l00203"></a>00203         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* getParentNode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00204"></a>00204 
<a name="l00212"></a>00212         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* getParentSceneNode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00213"></a>00213 
<a name="l00215"></a><a class="code" href="classOgre_1_1MovableObject.html#aff1706913baf992f108cc0fe4c95a53b">00215</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject.html#aff1706913baf992f108cc0fe4c95a53b" title="Gets whether the parent node is a TagPoint (or a SceneNode)">isParentTagPoint</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mParentIsTagPoint; }
<a name="l00216"></a>00216 
<a name="l00219"></a>00219         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyAttached(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* parent, <span class="keywordtype">bool</span> isTagPoint = <span class="keyword">false</span>);
<a name="l00220"></a>00220 
<a name="l00222"></a>00222         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isAttached(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00223"></a>00223 
<a name="l00225"></a>00225         <span class="keyword">virtual</span> <span class="keywordtype">void</span> detachFromParent(<span class="keywordtype">void</span>);
<a name="l00226"></a>00226 
<a name="l00230"></a>00230         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isInScene(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00231"></a>00231 
<a name="l00234"></a>00234         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyMoved(<span class="keywordtype">void</span>);
<a name="l00235"></a>00235 
<a name="l00241"></a>00241         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyCurrentCamera(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00242"></a>00242 
<a name="l00247"></a>00247         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBoundingBox(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00248"></a>00248 
<a name="l00252"></a>00252         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00253"></a>00253 
<a name="l00255"></a>00255         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getWorldBoundingBox(<span class="keywordtype">bool</span> derive = <span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00257"></a>00257         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; getWorldBoundingSphere(<span class="keywordtype">bool</span> derive = <span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00263"></a>00263         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue) = 0;
<a name="l00264"></a>00264 
<a name="l00279"></a>00279         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setVisible(<span class="keywordtype">bool</span> visible);
<a name="l00280"></a>00280 
<a name="l00285"></a>00285         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getVisible(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00286"></a>00286 
<a name="l00291"></a>00291         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isVisible(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00292"></a>00292 
<a name="l00298"></a><a class="code" href="classOgre_1_1MovableObject.html#a3774342d37fb670430d834aa914a3be5">00298</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#a3774342d37fb670430d834aa914a3be5" title="Sets the distance at which the object is no longer rendered.">setRenderingDistance</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dist) { 
<a name="l00299"></a>00299             mUpperDistance = dist; 
<a name="l00300"></a>00300             mSquaredUpperDistance = mUpperDistance * mUpperDistance;
<a name="l00301"></a>00301         }
<a name="l00302"></a>00302 
<a name="l00304"></a><a class="code" href="classOgre_1_1MovableObject.html#a97501f320f00fb5255d76fe3b20903d2">00304</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1MovableObject.html#a97501f320f00fb5255d76fe3b20903d2" title="Gets the distance at which batches are no longer rendered.">getRenderingDistance</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUpperDistance; }        
<a name="l00305"></a>00305 
<a name="l00311"></a><a class="code" href="classOgre_1_1MovableObject.html#a9ad2786aa67624f26c7ff245c673ad5e">00311</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#a9ad2786aa67624f26c7ff245c673ad5e" title="Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered...">setRenderingMinPixelSize</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> pixelSize) { 
<a name="l00312"></a>00312             mMinPixelSize = pixelSize; 
<a name="l00313"></a>00313         }
<a name="l00314"></a>00314 
<a name="l00317"></a><a class="code" href="classOgre_1_1MovableObject.html#a1025983039f59637e9dde740b5013175">00317</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1MovableObject.html#a1025983039f59637e9dde740b5013175" title="Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered...">getRenderingMinPixelSize</a>()<span class="keyword"> const </span>{ 
<a name="l00318"></a>00318             <span class="keywordflow">return</span> mMinPixelSize; 
<a name="l00319"></a>00319         }
<a name="l00320"></a>00320 
<a name="l00328"></a><a class="code" href="classOgre_1_1MovableObject.html#ab07068e26732de24aaf24330e9d0ec81">00328</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#ab07068e26732de24aaf24330e9d0ec81">setUserAny</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; anything) { getUserObjectBindings().setUserAny(anything); }
<a name="l00329"></a>00329 
<a name="l00333"></a><a class="code" href="classOgre_1_1MovableObject.html#a70a42d28867f1559f1bd71baf31f83e4">00333</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; <a class="code" href="classOgre_1_1MovableObject.html#a70a42d28867f1559f1bd71baf31f83e4">getUserAny</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> getUserObjectBindings().getUserAny(); }
<a name="l00334"></a>00334 
<a name="l00339"></a><a class="code" href="classOgre_1_1MovableObject.html#aaac5bf65835f733433f3338132f2f01f">00339</a>         <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a>&amp; <a class="code" href="classOgre_1_1MovableObject.html#aaac5bf65835f733433f3338132f2f01f" title="Return an instance of user objects binding associated with this class.">getUserObjectBindings</a>() { <span class="keywordflow">return</span> mUserObjectBindings; }
<a name="l00340"></a>00340 
<a name="l00345"></a><a class="code" href="classOgre_1_1MovableObject.html#abbf5cf5545c219ce9be1997ff5dd2204">00345</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a>&amp; <a class="code" href="classOgre_1_1MovableObject.html#abbf5cf5545c219ce9be1997ff5dd2204" title="Return an instance of user objects binding associated with this class.">getUserObjectBindings</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUserObjectBindings; }
<a name="l00346"></a>00346 
<a name="l00359"></a>00359         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRenderQueueGroup(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> queueID);
<a name="l00360"></a>00360 
<a name="l00376"></a>00376         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRenderQueueGroupAndPriority(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> queueID, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> priority);
<a name="l00377"></a>00377 
<a name="l00379"></a>00379         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> getRenderQueueGroup(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00380"></a>00380 
<a name="l00382"></a>00382         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; _getParentNodeFullTransform(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00383"></a>00383 
<a name="l00391"></a><a class="code" href="classOgre_1_1MovableObject.html#aa202386b8336ed756c3bd1ff5a74f54d">00391</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#aa202386b8336ed756c3bd1ff5a74f54d" title="Sets the query flags for this object.">setQueryFlags</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> flags) { mQueryFlags = flags; }
<a name="l00392"></a>00392 
<a name="l00395"></a><a class="code" href="classOgre_1_1MovableObject.html#a146b6b8afa6de9a2058f730aa3f7b25c">00395</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#a146b6b8afa6de9a2058f730aa3f7b25c" title="As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this ob...">addQueryFlags</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> flags) { mQueryFlags |= flags; }
<a name="l00396"></a>00396             
<a name="l00399"></a><a class="code" href="classOgre_1_1MovableObject.html#a8e039c80d31e36c17f4e7fc85e5c6cdc">00399</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#a8e039c80d31e36c17f4e7fc85e5c6cdc" title="As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this o...">removeQueryFlags</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> flags) { mQueryFlags &amp;= ~flags; }
<a name="l00400"></a>00400         
<a name="l00402"></a><a class="code" href="classOgre_1_1MovableObject.html#a5c40b9b7d9f3231f9ba16a3514f7495a">00402</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1MovableObject.html#a5c40b9b7d9f3231f9ba16a3514f7495a" title="Returns the query flags relevant for this object.">getQueryFlags</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mQueryFlags; }
<a name="l00403"></a>00403 
<a name="l00406"></a><a class="code" href="classOgre_1_1MovableObject.html#ad8db1f22329b2a96f2aed7260d565944">00406</a>         <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#ad8db1f22329b2a96f2aed7260d565944" title="Set the default query flags for all future MovableObject instances.">setDefaultQueryFlags</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> flags) { msDefaultQueryFlags = flags; }
<a name="l00407"></a>00407 
<a name="l00410"></a><a class="code" href="classOgre_1_1MovableObject.html#a01f48775e48b672d7796311f3ffe2930">00410</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1MovableObject.html#a01f48775e48b672d7796311f3ffe2930" title="Get the default query flags for all future MovableObject instances.">getDefaultQueryFlags</a>() { <span class="keywordflow">return</span> msDefaultQueryFlags; }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412         
<a name="l00419"></a><a class="code" href="classOgre_1_1MovableObject.html#a9421323e0ef6082d8a293aef0ba4666d">00419</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#a9421323e0ef6082d8a293aef0ba4666d" title="Sets the visiblity flags for this object.">setVisibilityFlags</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> flags) { mVisibilityFlags = flags; }
<a name="l00420"></a>00420 
<a name="l00423"></a><a class="code" href="classOgre_1_1MovableObject.html#adff2fa7a7c56ba06d25d2dfa376fd677">00423</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#adff2fa7a7c56ba06d25d2dfa376fd677" title="As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on th...">addVisibilityFlags</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> flags) { mVisibilityFlags |= flags; }
<a name="l00424"></a>00424             
<a name="l00427"></a><a class="code" href="classOgre_1_1MovableObject.html#ab7bebfd93631ffe82f95ad7c73b77e24">00427</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#ab7bebfd93631ffe82f95ad7c73b77e24" title="As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on t...">removeVisibilityFlags</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> flags) { mVisibilityFlags &amp;= ~flags; }
<a name="l00428"></a>00428         
<a name="l00430"></a><a class="code" href="classOgre_1_1MovableObject.html#a5ca10844726d16c8ed47395a6b22d33a">00430</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1MovableObject.html#a5ca10844726d16c8ed47395a6b22d33a" title="Returns the visibility flags relevant for this object.">getVisibilityFlags</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVisibilityFlags; }
<a name="l00431"></a>00431 
<a name="l00434"></a><a class="code" href="classOgre_1_1MovableObject.html#ac2904cb122ab8c8d5066abefb29dfa96">00434</a>         <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#ac2904cb122ab8c8d5066abefb29dfa96" title="Set the default visibility flags for all future MovableObject instances.">setDefaultVisibilityFlags</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> flags) { msDefaultVisibilityFlags = flags; }
<a name="l00435"></a>00435         
<a name="l00438"></a><a class="code" href="classOgre_1_1MovableObject.html#a2eb94fea5944cf0d33702a75cfa14a74">00438</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1MovableObject.html#a2eb94fea5944cf0d33702a75cfa14a74" title="Get the default visibility flags for all future MovableObject instances.">getDefaultVisibilityFlags</a>() { <span class="keywordflow">return</span> msDefaultVisibilityFlags; }
<a name="l00439"></a>00439 
<a name="l00445"></a><a class="code" href="classOgre_1_1MovableObject.html#a9efbb3928b834d4f125303698034951e">00445</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#a9efbb3928b834d4f125303698034951e" title="Sets a listener for this object.">setListener</a>(<a class="code" href="classOgre_1_1MovableObject_1_1Listener.html" title="Listener which gets called back on MovableObject events.">Listener</a>* listener) { mListener = listener; }
<a name="l00446"></a>00446 
<a name="l00449"></a><a class="code" href="classOgre_1_1MovableObject.html#adf305fd600ec68543ed68e0c0cef6196">00449</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObject_1_1Listener.html" title="Listener which gets called back on MovableObject events.">Listener</a>* <a class="code" href="classOgre_1_1MovableObject.html#adf305fd600ec68543ed68e0c0cef6196" title="Gets the current listener for this object.">getListener</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mListener; }
<a name="l00450"></a>00450 
<a name="l00469"></a>00469         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; queryLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00470"></a>00470 
<a name="l00475"></a><a class="code" href="classOgre_1_1MovableObject.html#a538d975b35be25e7d705b6310ec3d84d">00475</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1MovableObject.html#a538d975b35be25e7d705b6310ec3d84d" title="Get a bitwise mask which will filter the lights affecting this object.">getLightMask</a>()<span class="keyword">const </span>{ <span class="keywordflow">return</span> mLightMask; }
<a name="l00482"></a>00482         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setLightMask(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> lightMask);
<a name="l00483"></a>00483 
<a name="l00490"></a><a class="code" href="classOgre_1_1MovableObject.html#adf4f61aeb45d61195c248757e3d1c6fe">00490</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>* <a class="code" href="classOgre_1_1MovableObject.html#adf4f61aeb45d61195c248757e3d1c6fe" title="Returns a pointer to the current list of lights for this object.">_getLightList</a>() { <span class="keywordflow">return</span> &amp;mLightList; }
<a name="l00491"></a>00491 
<a name="l00493"></a><a class="code" href="classOgre_1_1MovableObject.html#a60b24cd45c8df45654dcfa14a1293a3b">00493</a>         <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a>* <a class="code" href="classOgre_1_1MovableObject.html#a60b24cd45c8df45654dcfa14a1293a3b" title="Define a default implementation of method from ShadowCaster which implements no shadows.">getEdgeList</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> NULL; }
<a name="l00495"></a><a class="code" href="classOgre_1_1MovableObject.html#ab7c2a8be6a9bd59e6c69ee2d76945500">00495</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject.html#ab7c2a8be6a9bd59e6c69ee2d76945500" title="Define a default implementation of method from ShadowCaster which implements no shadows.">hasEdgeList</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00497"></a>00497         ShadowRenderableListIterator getShadowVolumeRenderableIterator(
<a name="l00498"></a>00498             <a class="code" href="group__General.html#ga79dcd426d291c31072c1ad6f183715d6" title="An enumeration of broad shadow techniques.">ShadowTechnique</a> shadowTechnique, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* light, 
<a name="l00499"></a>00499             <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>* indexBuffer, 
<a name="l00500"></a>00500             <span class="keywordtype">bool</span> extrudeVertices, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> extrusionDist, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags = 0);
<a name="l00501"></a>00501         
<a name="l00503"></a>00503         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getLightCapBounds(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00505"></a>00505         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getDarkCapBounds(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>&amp; light, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dirLightExtrusionDist) <span class="keyword">const</span>;
<a name="l00518"></a><a class="code" href="classOgre_1_1MovableObject.html#acbfc4840224e8b6ed6e27849d3341675">00518</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#acbfc4840224e8b6ed6e27849d3341675" title="Sets whether or not this object will cast shadows.">setCastShadows</a>(<span class="keywordtype">bool</span> enabled) { mCastShadows = enabled; }
<a name="l00520"></a><a class="code" href="classOgre_1_1MovableObject.html#a70bca10cdeac93142d9f93ed0cf9c4c5">00520</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject.html#a70bca10cdeac93142d9f93ed0cf9c4c5" title="Returns whether shadow casting is enabled for this object.">getCastShadows</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCastShadows; }
<a name="l00524"></a>00524         <span class="keywordtype">bool</span> getReceivesShadows();
<a name="l00525"></a>00525             
<a name="l00527"></a>00527         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getPointExtrusionDistance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* l) <span class="keyword">const</span>;
<a name="l00538"></a>00538         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getTypeFlags(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00539"></a>00539 
<a name="l00551"></a>00551         <span class="keyword">virtual</span> <span class="keywordtype">void</span> visitRenderables(<a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor, 
<a name="l00552"></a>00552             <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span>) = 0;
<a name="l00553"></a>00553 
<a name="l00562"></a><a class="code" href="classOgre_1_1MovableObject.html#a2b559ddd8df033cafa5d64502c7d0c3a">00562</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObject.html#a2b559ddd8df033cafa5d64502c7d0c3a" title="Sets whether or not the debug display of this object is enabled.">setDebugDisplayEnabled</a>(<span class="keywordtype">bool</span> enabled) { mDebugDisplay = enabled; }
<a name="l00564"></a><a class="code" href="classOgre_1_1MovableObject.html#a39cfd5b78a4326156accf5ed3146ddc6">00564</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObject.html#a39cfd5b78a4326156accf5ed3146ddc6" title="Gets whether debug display of this object is enabled.">isDebugDisplayEnabled</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDebugDisplay; }
<a name="l00565"></a>00565 
<a name="l00566"></a>00566 
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 
<a name="l00570"></a>00570     };
<a name="l00571"></a>00571 
<a name="l00577"></a><a class="code" href="classOgre_1_1MovableObjectFactory.html">00577</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject, and can be registered with Root in order to allow all clients to produce new instances of this object, integrated with the standard Ogre processing.">MovableObjectFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">MovableAlloc</a>
<a name="l00578"></a>00578     {
<a name="l00579"></a>00579     <span class="keyword">protected</span>:
<a name="l00581"></a><a class="code" href="classOgre_1_1MovableObjectFactory.html#ad35a2db6426d02a75b85f133a26d5387">00581</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classOgre_1_1MovableObjectFactory.html#ad35a2db6426d02a75b85f133a26d5387" title="Type flag, allocated if requested.">mTypeFlag</a>;
<a name="l00582"></a>00582 
<a name="l00584"></a>00584         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* createInstanceImpl(
<a name="l00585"></a>00585             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* params = 0) = 0;
<a name="l00586"></a>00586     <span class="keyword">public</span>:
<a name="l00587"></a><a class="code" href="classOgre_1_1MovableObjectFactory.html#a20ebc986aa86806dc61a95e86312500f">00587</a>         <a class="code" href="classOgre_1_1MovableObjectFactory.html#a20ebc986aa86806dc61a95e86312500f">MovableObjectFactory</a>() : mTypeFlag(0xFFFFFFFF) {}
<a name="l00588"></a><a class="code" href="classOgre_1_1MovableObjectFactory.html#a102fc90d87f01bbd0680ccb58a2d5050">00588</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObjectFactory.html#a102fc90d87f01bbd0680ccb58a2d5050">~MovableObjectFactory</a>() {}
<a name="l00590"></a>00590         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00591"></a>00591 
<a name="l00599"></a>00599         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* createInstance(
<a name="l00600"></a>00600             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* manager, 
<a name="l00601"></a>00601             <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* params = 0);
<a name="l00603"></a>00603         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroyInstance(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* obj) = 0;
<a name="l00604"></a>00604 
<a name="l00618"></a><a class="code" href="classOgre_1_1MovableObjectFactory.html#a80346bc406655855ec5e0eef198900f2">00618</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovableObjectFactory.html#a80346bc406655855ec5e0eef198900f2" title="Does this factory require the allocation of a &#39;type flag&#39;, used to selectively include / exclude this...">requestTypeFlags</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00627"></a><a class="code" href="classOgre_1_1MovableObjectFactory.html#afe63ec95c506e97e9abca23b7fd1a537">00627</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovableObjectFactory.html#afe63ec95c506e97e9abca23b7fd1a537" title="Notify this factory of the type mask to apply.">_notifyTypeFlags</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flag) { mTypeFlag = flag; }
<a name="l00628"></a>00628 
<a name="l00634"></a><a class="code" href="classOgre_1_1MovableObjectFactory.html#a9b2028dca564c74453994926db4f50d0">00634</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1MovableObjectFactory.html#a9b2028dca564c74453994926db4f50d0" title="Gets the type flag for this factory.">getTypeFlags</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTypeFlag; }
<a name="l00635"></a>00635 
<a name="l00636"></a>00636     };
<a name="l00640"></a>00640 }
<a name="l00641"></a>00641 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
